package org.toilelibre.libe.javawrapper;


import java.io.IOException;
import java.util.Properties;

public class RWrapperRuntimeImpl implements RWrapper {

    private static RWrapperConf instance = null;
    //R :
    private static final String COMMAND_LINE = "R --vanilla --no-save --slave";
    /*sh :
    private static final String COMMAND_LINE = "sh";*/
    private int occ = 0;

    /*
     * (non-Javadoc)
     * 
     * @see fr.edf.mde.rinvoker.RWrapper#initLocalInstance()
     */
    public RWrapperConf initLocalInstance () {
        Properties rsc = System.getProperties ();
        if (RWrapperRuntimeImpl.instance == null) {
            Process s = null;
            try {
                s = Runtime.getRuntime ().exec (RWrapperRuntimeImpl.COMMAND_LINE);
            } catch (IOException e) {
                e.printStackTrace ();
            }
            RWrapperRuntimeImpl.instance = new RWrapperRuntimeConfImpl (rsc, s);
        }
        return RWrapperRuntimeImpl.instance;
    }

    public Object eval (RWrapperConf rwc, String expr) {
        return this.runProcess (rwc, expr);
    }

    private void read (Process p, StringBuffer out) throws IOException {
        int c = 0;
        while (occ != 0 && p.getInputStream ().available () == 0
                && p.getErrorStream ().available () == 0);   
        occ++;

        while (p.getErrorStream ().available () > 0) {
            c = p.getErrorStream ().read ();
            out.append ((char) c);
        }

        if (out.length () > 0) {
            throw new IllegalStateException (out.toString ());
        }

        while (p.getInputStream ().available () > 0) {
            c = p.getInputStream ().read ();
            out.append ((char) c);
        }
    }

    private String runProcess (RWrapperConf rwc, String expr) {
        try {
            final StringBuffer out = new StringBuffer ("");
            final Process p = ((Process) rwc.getS ());
            p.getOutputStream ().write (("\n" + expr + "\n").getBytes (), 0,
                    expr.length () + 2);
            p.getOutputStream ().flush ();

            this.read (p, out);

            return out.toString ();
        } catch (IOException e) {
            e.printStackTrace ();
            return null;
        }
    }
}
